<script setup lang="ts">
    import { onMounted } from 'vue'

    let isDragging = false
    let prevTouchEventSreenY: undefined | number = undefined
    onMounted(() => {
        const handle = document.getElementsByClassName(
            'handle'
        )[0] as HTMLElement

        const content = document.getElementsByClassName(
            'content'
        )[0] as HTMLElement

        handle.addEventListener(
            'touchstart',
            () => {
                isDragging = true
            },
            { passive: true } // cf. https://github.com/WICG/EventListenerOptions/blob/gh-pages/explainer.md
        )
        document.addEventListener('touchend', () => {
            isDragging = false
            prevTouchEventSreenY = undefined
        })
        document.addEventListener('touchmove', (touchEvent) => {
            if (isDragging) {
                const actualHeight = content.offsetHeight
                const targetheight =
                    actualHeight - getTouchEventMovementY(touchEvent)
                content.style.height = `${targetheight}px`
            }
        })
    })

    /**
     * Note, ne considère que le premier doigt
     */
    function getTouchEventMovementY(touchEvent: TouchEvent): number {
        prevTouchEventSreenY ??= touchEvent.touches[0].screenY
        const delta = touchEvent.touches[0].screenY - prevTouchEventSreenY
        prevTouchEventSreenY = touchEvent.touches[0].screenY
        return delta
    }
</script>
<template>
    <div class="sheet-container">
        <div class="fab-container pr-3"><slot name="fab"></slot></div>
        <section class="sheet">
            <div class="handle">
                <hr class="bar" />
                <slot name="header"></slot>
            </div>
            <div class="content">
                <slot></slot>
            </div>
        </section>
    </div>
</template>
<style scoped lang="scss">
    .sheet-container {
        touch-action: none;
        position: fixed;
        bottom: 0;
        left: 0;
        right: 0;
        z-index: 100;
        .fab-container {
            text-align: right;
            padding-bottom: 15px;
        }
        .sheet {
            box-shadow: 0px 0px 5px 0px rgba(0, 0, 0, 0.4);
            border-radius: 15px 15px 0 0;
            overflow: hidden;
            background-color: #f9fbfd;
            .handle {
                .bar {
                    margin: 8px auto;
                    width: 65px;
                    height: 5px;
                    background: #bfbfbf;
                    border: none;
                    border-radius: 2.5px;
                }
            }
            .content {
                height: 0vh;
                max-height: 70vh;
                overflow: auto;
            }
        }
    }
</style>
